import L from "leaflet";
L.TileLayer.ColorFilter = L.TileLayer.extend({
    intialize: function (url, options) {
        L.TileLayer.prototype.initialize.call(this, url, options);
    },
    colorFilter: function () {
        var colorFilterOptions = this.options.filter ? this.options.filter : {};
        var filterSettings = "";
        for (var key in colorFilterOptions) {
            if (key === "hue-rotate") {
                filterSettings += "".concat(key, "(").concat(colorFilterOptions[key], "deg) ");
                continue;
            }
            else if (key === "blur") {
                filterSettings += "".concat(key, "(").concat(colorFilterOptions[key], "px) ");
                continue;
            }
            else {
                filterSettings += "".concat(key, "(").concat(colorFilterOptions[key], "%) ");
            }
        }
        return filterSettings;
    },
    _initContainer: function () {
        var tile = L.TileLayer.prototype._initContainer.call(this);
        this._container.style.filter = this.colorFilter();
    },
    updateFilter: function (newFilter) {
        this.options.filter = newFilter;
        if (this._container) {
            this._container.style.filter = this.colorFilter();
        }
    },
});
export default L.tileLayer.colorFilter = function (url, options) {
    return new L.TileLayer.ColorFilter(url, options);
};
