import { Symbolizer } from './Symbolizer';
import { PolyBase } from './Symbolizer.PolyBase';
export var LineSymbolizer = L.Polyline.extend({
    includes: [Symbolizer.prototype, PolyBase],
    initialize: function (feature, pxPerExtent) {
        this.properties = feature.properties;
        this._makeFeatureParts(feature, pxPerExtent);
    },
    makeInteractive: function () {
        this._pxBounds = this._getPixelBounds();
    },
    _makeFeatureParts: function (feat, pxPerExtent) {
        var rings = feat.geometry;
        var coord;
        this._parts = [];
        for (var i = 0; i < rings.length; i++) {
            var ring = rings[i];
            var part = [];
            for (var j = 0; j < ring.length; j++) {
                coord = ring[j];
                part.push(L.point(coord).scaleBy(pxPerExtent));
            }
            this._parts.push(part);
        }
    },
    render: function (renderer, style) {
        style.fill = false;
        Symbolizer.prototype.render.call(this, renderer, style);
        this._updatePath();
    },
    updateStyle: function (renderer, style) {
        style.fill = false;
        Symbolizer.prototype.updateStyle.call(this, renderer, style);
    },
});
