export var Symbolizer = L.Class.extend({
    render: function (renderer, style) {
        this._renderer = renderer;
        this.options = style;
        renderer._initPath(this);
        renderer._updateStyle(this);
    },
    updateStyle: function (renderer, style) {
        this.options = style;
        renderer._updateStyle(this);
    },
    _getPixelBounds: function () {
        var parts = this._parts;
        var bounds = L.bounds([]);
        for (var i = 0; i < parts.length; i++) {
            var part = parts[i];
            for (var j = 0; j < part.length; j++) {
                bounds.extend(part[j]);
            }
        }
        var w = this._clickTolerance(), p = new L.Point(w, w);
        bounds.min._subtract(p);
        bounds.max._add(p);
        return bounds;
    },
    _clickTolerance: L.Path.prototype._clickTolerance,
});
