var MapBoxZoomControl = (function () {
    function MapBoxZoomControl() {
    }
    MapBoxZoomControl.prototype.onAdd = function (map) {
        this._map = map;
        this._container = document.createElement("div");
        this._container.className = "mapboxgl-ctrl mapboxgl-ctrl-group mapboxgl-ctrl-zoom";
        this.addEventListeners();
        return this._container;
    };
    MapBoxZoomControl.prototype.updateZoomLevel = function () {
        this._container.innerHTML = "".concat(this._map.getZoom().toFixed(2));
    };
    MapBoxZoomControl.prototype.addEventListeners = function () {
        this._map.on("render", this.updateZoomLevel.bind(this));
        this._map.on("zoomIn", this.updateZoomLevel.bind(this));
        this._map.on("zoomOut", this.updateZoomLevel.bind(this));
    };
    MapBoxZoomControl.prototype.onRemove = function () {
        this._container.parentNode.removeChild(this._container);
        this._map = undefined;
    };
    return MapBoxZoomControl;
}());
export default MapBoxZoomControl;
