import Layer from "./Layer";
import IBounds from "./IBounds";
export default abstract class AbstractMap {
    static readonly INIT_LEAFLET_CENTER: number[];
    static readonly INIT_MAPBOX_CENTER: number[];
    static readonly INIT_ZOOM = 10;
    private map;
    container: string;
    center: number[];
    zoom: number;
    maxBounds: number[];
    constructor(container: string, center?: number[], zoom?: number);
    initMap(options?: any): void;
    getInitCenter(): number[];
    setInitCenter(center: number[]): void;
    getInitZoom(): number;
    setInitZoom(zoom: number): void;
    setMaxZoom(maxZoom: number): void;
    setMinZoom(minZoom: number): void;
    getMap(): any;
    hasMap(): boolean;
    protected abstract doInitMap(options?: any): any;
    abstract setMaxBounds(bounds: IBounds): void;
    abstract addLayer(layer: Layer, beforeId?: string): void;
    abstract moveLayer(id: string, beforeId: string): void;
    abstract removeLayer(id: string): void;
    abstract getLayer(id: string): Layer;
    abstract close(): void;
}
