var AbstractMap = (function () {
    function AbstractMap(container, center, zoom) {
        if (center === void 0) { center = AbstractMap.INIT_LEAFLET_CENTER; }
        if (zoom === void 0) { zoom = AbstractMap.INIT_ZOOM; }
        this.container = container;
        this.center = center;
        this.zoom = zoom;
    }
    AbstractMap.prototype.initMap = function (options) {
        this.map = this.doInitMap(options);
    };
    AbstractMap.prototype.getInitCenter = function () {
        return this.center;
    };
    AbstractMap.prototype.setInitCenter = function (center) {
        this.center = center;
    };
    AbstractMap.prototype.getInitZoom = function () {
        return this.zoom;
    };
    AbstractMap.prototype.setInitZoom = function (zoom) {
        this.zoom = zoom;
    };
    AbstractMap.prototype.setMaxZoom = function (maxZoom) {
        if (this.hasMap()) {
            this.map.setMaxZoom(maxZoom);
        }
    };
    AbstractMap.prototype.setMinZoom = function (minZoom) {
        if (this.hasMap()) {
            this.map.setMinZoom(minZoom);
        }
    };
    AbstractMap.prototype.getMap = function () {
        return this.map ? this.map : null;
    };
    AbstractMap.prototype.hasMap = function () {
        return this.map ? true : false;
    };
    AbstractMap.INIT_LEAFLET_CENTER = [31.324152, 120.428295];
    AbstractMap.INIT_MAPBOX_CENTER = [120.42608, 31.32629];
    AbstractMap.INIT_ZOOM = 10;
    return AbstractMap;
}());
export default AbstractMap;
