import MapBoxLayerTypeConsts from '../mapbox/consts/MapBoxLayerTypeConsts';
import MapBoxSourceConsts from '../mapbox/consts/MapBoxSourceConsts';
import MapBoxLayer from '../mapbox/MapBoxLayer';
import MapBoxLayerPaint from '../mapbox/MapBoxLayerPaint';
import MapBoxSource from '../mapbox/MapBoxSource';
import MapBoxStyle from '../mapbox/MapBoxStyle';
var MapBoxStyleBuilder = (function () {
    function MapBoxStyleBuilder() {
        this.style = new MapBoxStyle();
    }
    MapBoxStyleBuilder.prototype.buildSource = function (id, url) {
        var source = new MapBoxSource();
        source.setType(MapBoxSourceConsts.SOURCE_TYPE_VECTOR);
        source.addTileUrl(url);
        this.style.addSource(id, source);
        return this;
    };
    MapBoxStyleBuilder.prototype.buildLayer = function (id, source, sourceLayer) {
        var layer = new MapBoxLayer(id);
        layer.setType(MapBoxLayerTypeConsts.FILL);
        layer.setSource(source);
        layer.setSourceLayer(sourceLayer);
        var paint = new MapBoxLayerPaint();
        paint.setFillColor("hsl(0, 76%, 53%)");
        layer.setPaint(paint);
        this.style.addLayer(layer);
        return this;
    };
    MapBoxStyleBuilder.prototype.build = function () {
        return this.style;
    };
    return MapBoxStyleBuilder;
}());
export default MapBoxStyleBuilder;
