var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import L from "leaflet";
import Layer from "../Layer";
var AbstractLeafletLayer = (function (_super) {
    __extends(AbstractLeafletLayer, _super);
    function AbstractLeafletLayer(id, url, pane) {
        if (pane === void 0) { pane = ""; }
        var _this = _super.call(this, id) || this;
        _this.zIndex = 20;
        _this.url = url;
        _this.pane = pane;
        return _this;
    }
    AbstractLeafletLayer.prototype.setCenter = function (center) {
        this.center = center;
    };
    AbstractLeafletLayer.prototype.setFilter = function (filter) {
        this.filter = filter;
    };
    AbstractLeafletLayer.prototype.setBounds = function (bounds) {
        this.bounds = bounds;
        if (this.getLayer()) {
            this.getLayer().options.bounds = this.getActualBounds();
        }
    };
    AbstractLeafletLayer.prototype.setSubdomains = function (domains) {
        this.subdomains = domains;
        if (this.getLayer()) {
            this.getLayer().options.subdomains = domains;
        }
    };
    AbstractLeafletLayer.prototype.getZIndex = function () {
        return this.zIndex;
    };
    AbstractLeafletLayer.prototype.getActualBounds = function () {
        if (this.bounds) {
            var minLatLng = this.createCoordinate(this.bounds.minLat, this.bounds.minLon);
            var maxLatLng = this.createCoordinate(this.bounds.maxLat, this.bounds.maxLon);
            return L.latLngBounds(minLatLng, maxLatLng);
        }
    };
    AbstractLeafletLayer.prototype.createCoordinate = function (lat, lon) {
        return L.latLng(lat, lon);
    };
    AbstractLeafletLayer.prototype.getLayerOptions = function () {
        if (this.pane != "") {
            return {
                id: this.id,
                center: this.center,
                maxZoom: this.maxZoom,
                minZoom: this.minZoom,
                bounds: this.getActualBounds(),
                filter: this.filter,
                zIndex: this.zIndex,
                pane: this.pane,
            };
        }
        else {
            return {
                id: this.id,
                center: this.center,
                maxZoom: this.maxZoom,
                minZoom: this.minZoom,
                bounds: this.getActualBounds(),
                filter: this.filter,
                zIndex: this.zIndex,
            };
        }
    };
    AbstractLeafletLayer.prototype.setMinZoom = function (minZoom) {
        _super.prototype.setMinZoom.call(this, minZoom);
        if (this.getLayer()) {
            this.getLayer().options.minZoom = minZoom;
        }
    };
    AbstractLeafletLayer.prototype.setMaxZoom = function (maxZoom) {
        _super.prototype.setMaxZoom.call(this, maxZoom);
        if (this.getLayer()) {
            this.getLayer().options.maxZoom = maxZoom;
        }
    };
    AbstractLeafletLayer.prototype.getCustomPane = function () {
        return this.pane;
    };
    AbstractLeafletLayer.prototype.on = function (eventName, map, props) {
        console.log("事件注册", eventName, map, props);
    };
    AbstractLeafletLayer.prototype.off = function (eventName) {
        console.log("事件取消", eventName);
    };
    AbstractLeafletLayer.MAX_ZINDEX = 99999999999;
    AbstractLeafletLayer.MIN_ZINDEX = -99999999999;
    AbstractLeafletLayer.ZINDEX_STEP = 20;
    return AbstractLeafletLayer;
}(Layer));
export default AbstractLeafletLayer;
