import { StyleFunction } from "leaflet";
import GeoJson from "../extra/GeoJson";
import AbstractLeafletLayer from "./AbstractLeafletLayer";
export default class LeafletGeojsonLayer extends AbstractLeafletLayer {
    data: any;
    style: StyleFunction;
    layer: any;
    bMask: boolean;
    constructor(id: string, data: any, style: StyleFunction, pane?: string, bMask?: boolean);
    setData(data: any): void;
    setStyle(style: StyleFunction): void;
    getLayer(): any;
    getBounds(): void;
    setZIndex(zIndex: number): void;
    static geom2GeoJson(feature: string, featureType?: string, featureProperties?: any): "" | GeoJson;
    static buildDefaultStyles: () => {
        stroke: boolean;
        color: string;
        opacity: number;
        fillColor: string;
    };
}
