var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import L from "leaflet";
import GeoJson from "../extra/GeoJson";
import AbstractLeafletLayer from "./AbstractLeafletLayer";
var LeafletGeojsonLayer = (function (_super) {
    __extends(LeafletGeojsonLayer, _super);
    function LeafletGeojsonLayer(id, data, style, pane, bMask) {
        if (pane === void 0) { pane = ""; }
        if (bMask === void 0) { bMask = false; }
        var _this = _super.call(this, id, undefined, pane) || this;
        if (bMask) {
            var outerRing = [
                [-180.0, 85.5],
                [180.0, 85.5],
                [180.0, -85.5],
                [-180.0, -85.5],
            ];
            if (data.geometry) {
                if (data.geometry.type === "MultiPolygon") {
                    var features = data.geometry.coordinates[0];
                    features.unshift(outerRing);
                }
                else if (data.geometry.type === "Polygon") {
                    var features = data.geometry.coordinates;
                    features.unshift(outerRing);
                }
            }
            else {
                if (data.type === "MultiPolygon") {
                    var features = data.coordinates[0];
                    features.unshift(outerRing);
                }
                else if (data.type === "Polygon") {
                    var features = data.coordinates;
                    features.unshift(outerRing);
                }
            }
            _this.data = data;
        }
        else {
            _this.data = data;
        }
        _this.style = style;
        return _this;
    }
    LeafletGeojsonLayer.prototype.setData = function (data) {
        this.data = data;
    };
    LeafletGeojsonLayer.prototype.setStyle = function (style) {
        this.style = style;
    };
    LeafletGeojsonLayer.prototype.getLayer = function () {
        if (this.layer) {
            return this.layer;
        }
        this.layer = L.geoJSON(this.data, this.pane == ""
            ? {
                style: this.style,
            }
            : { style: this.style, pane: this.pane });
        return this.layer;
    };
    LeafletGeojsonLayer.prototype.getBounds = function () {
        this.getLayer().getBounds();
    };
    LeafletGeojsonLayer.prototype.setZIndex = function (zIndex) {
        if (this.layer) {
            this.layer.setZIndex(zIndex);
        }
    };
    LeafletGeojsonLayer.geom2GeoJson = function (feature, featureType, featureProperties) {
        if (featureType === void 0) { featureType = "Feature"; }
        if (featureProperties === void 0) { featureProperties = {}; }
        if (!feature || feature === "") {
            return "";
        }
        return new GeoJson(JSON.parse(feature), featureType, featureProperties);
    };
    LeafletGeojsonLayer.buildDefaultStyles = function () {
        return {
            stroke: true,
            color: "red",
            opacity: 0.8,
            fillColor: "green",
        };
    };
    return LeafletGeojsonLayer;
}(AbstractLeafletLayer));
export default LeafletGeojsonLayer;
