import L, { LatLng } from "leaflet";
import "leaflet/dist/leaflet.css";
import AbstractMap from "../AbstractMap";
import IBounds from "../IBounds";
import Layer from "../Layer";
import AbstractLeafletLayer from "./AbstractLeafletLayer";
export default class LeafletMap extends AbstractMap {
    static readonly EVENT_CLICK = "click";
    static readonly EVENT_DBCLICK = "dblclick";
    static readonly EVENT_MOUSE_DOWN = "mousedown";
    static readonly EVENT_MOUSE_UP = "mouseup";
    static readonly EVENT_MOUSE_MOVE = "mousemove";
    static readonly EVENT_ZOOM_MOVE = "zoom move";
    static readonly POSITION_TOP_LEFT = "topleft";
    static readonly POSITION_TOP_RIGHT = "topright";
    static readonly POSITION_BOTTOM_LEFT = "bottomleft";
    static readonly POSITION_BOTTOM_RIGHT = "bottomright";
    layers: Map<string, Layer>;
    sideControl: any;
    constructor(container: string, options: any, initZoom?: number, initCenter?: number[]);
    doInitMap(options: any): L.Map;
    getDefaultMapOption(): {
        zoomControl: boolean;
        attributionControl: boolean;
        maxBounds: L.LatLngBounds;
        maxZoom: number;
        minZoom: number;
    };
    addMousePosition(position?: string): void;
    addZoomSlider(position?: string): void;
    addZoomLable(position?: string): void;
    addSideBySide(leafLayer: AbstractLeafletLayer, rightLayer: AbstractLeafletLayer): void;
    getSideControl(): any;
    setMaxBounds(bounds: IBounds): void;
    addLayer(layer: AbstractLeafletLayer): void;
    addOtherLayer(layer: any, id: string): void;
    moveLayer(id: string, beforeId: string): void;
    removeLayer(id: string): void;
    getLayer(id: string): Layer;
    setView(center: LatLng, zoom: number, options?: any): void;
    fitBounds(bounds: any): void;
    close(): void;
    createPane(panelId: string): void;
}
