var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import L from "leaflet";
import AbstractLeafletLayer from "./AbstractLeafletLayer";
import protobuf from "../../control/layer-plugin/vector/L.VectorGrid.Protobuf";
import "../../control/layer-plugin/L.TileLayer.NoGap";
var LeafletVectorTileLayer = (function (_super) {
    __extends(LeafletVectorTileLayer, _super);
    function LeafletVectorTileLayer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LeafletVectorTileLayer.prototype.getLayer = function () {
        var _a, _b;
        if (this.layer) {
            return this.layer;
        }
        var vectorTileOptions = this.pane == "" ? {
            layerURL: this.url,
            vectorTileLayerStyles: (_a = {},
                _a[this.id] = this.layerStyle,
                _a),
            interactive: true,
            getFeatureId: function (feature) {
                return feature.properties.id;
            },
            zIndex: this.zIndex
        } :
            {
                layerURL: this.url,
                vectorTileLayerStyles: (_b = {},
                    _b[this.id] = this.layerStyle,
                    _b),
                interactive: true,
                getFeatureId: function (feature) {
                    return feature.properties.id;
                },
                pane: this.pane,
                zIndex: this.zIndex
            };
        this.layer = protobuf(this.url, vectorTileOptions);
        return this.layer;
    };
    LeafletVectorTileLayer.prototype.setZIndex = function (zIndex) {
        this.zIndex = zIndex;
        if (this.layer) {
            this.layer.setZIndex(zIndex);
        }
    };
    LeafletVectorTileLayer.prototype.setLayerStyle = function (layerStyle) {
        this.layerStyle = layerStyle;
    };
    LeafletVectorTileLayer.getDefaultLayerStyle = function () {
        return {
            weight: 2,
            color: "red",
            opacity: 1,
            fillColor: "green",
            fill: true,
            fillOpacity: 0.7,
        };
    };
    LeafletVectorTileLayer.prototype.on = function (eventName, map, props) {
        if (this.getLayer()) {
            this.getLayer().on(eventName, function (e) {
                var properties = e.layer.properties;
                var content = "";
                console.log('111111', properties);
                if (props) {
                    for (var srcKey in props) {
                        for (var destKey in properties) {
                            if (properties.hasOwnProperty(destKey) && srcKey === destKey) {
                                content += "<p>".concat(props[srcKey], ":").concat(properties[destKey], "</p>");
                            }
                        }
                    }
                }
                else {
                    for (var key in properties) {
                        if (properties.hasOwnProperty(key)) {
                            content += "<p>".concat(key, ":").concat(properties[key], "</p>");
                        }
                    }
                }
                L.popup()
                    .setContent(content)
                    .setLatLng(e.latlng)
                    .openOn(map);
            });
        }
    };
    LeafletVectorTileLayer.prototype.off = function (eventName) {
        if (this.getLayer()) {
            this.getLayer().off(eventName);
        }
    };
    return LeafletVectorTileLayer;
}(AbstractLeafletLayer));
export default LeafletVectorTileLayer;
