import AbstractMap from "../AbstractMap";
import mapboxgl from "mapbox-gl";
import MapBoxStyle from "./MapBoxStyle";
import IBounds from "../IBounds";
import MapBoxSource from "./MapBoxSource";
import MapBoxLayer from "./MapBoxLayer";
import Layer from "../Layer";
import "mapbox-gl/dist/mapbox-gl.css";
export default class MapBoxMap extends AbstractMap {
    static readonly CONTROL_POSITION_TOP_LEFT = "top-left";
    static readonly CONTROL_POSITION_TOP_RIGHT = "top-left";
    static readonly CONTROL_POSITION_BOTTOM_LEFT = "bottom-left";
    static readonly CONTROL_POSITION_BOTTOM_RIGHT = "bottom-right";
    style: MapBoxStyle | string;
    constructor(container: string, style: MapBoxStyle | string, initCenter?: number[], initZoom?: number);
    doInitMap(): mapboxgl.Map;
    addNavigationControl(positon?: string): void;
    addAttribution(positon?: string): void;
    setMaxBounds(bounds: IBounds): void;
    addSource(source: MapBoxSource): void;
    getSource(id: string): any;
    removeSource(id: string): void;
    addLayer(layer: MapBoxLayer, beforeId?: string): void;
    moveLayer(id: string, beforeId: string): void;
    removeLayer(id: string): void;
    getLayer(id: string): Layer;
    close(): void;
}
