var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import AbstractMap from "../AbstractMap";
import mapboxgl from "mapbox-gl";
import { style2Json } from "../../util/JsonUtils";
import MapBoxZoomControl from "../../control/zoom-label/MapBoxZoomControl";
import "mapbox-gl/dist/mapbox-gl.css";
var MapBoxMap = (function (_super) {
    __extends(MapBoxMap, _super);
    function MapBoxMap(container, style, initCenter, initZoom) {
        if (initCenter === void 0) { initCenter = AbstractMap.INIT_MAPBOX_CENTER; }
        if (initZoom === void 0) { initZoom = AbstractMap.INIT_ZOOM; }
        var _this = _super.call(this, container, initCenter, initZoom) || this;
        _this.style = style;
        _this.initMap();
        return _this;
    }
    MapBoxMap.prototype.doInitMap = function () {
        var style = typeof this.style === "string"
            ? this.style
            : JSON.parse(style2Json(this.style));
        var map = new mapboxgl.Map({
            container: this.container,
            style: style,
            center: [this.center[0], this.center[1]],
            zoom: this.zoom,
            accessToken: "pk.eyJ1IjoiYXBwbGV5ayIsImEiOiJja2M5MWIydHQxZ3ZzMnlvYm85Nndtb21qIn0.RKnwYJ-7A9OxlGxFJkWCFA",
        });
        return map;
    };
    MapBoxMap.prototype.addNavigationControl = function (positon) {
        if (positon === void 0) { positon = MapBoxMap.CONTROL_POSITION_TOP_RIGHT; }
        if (this.hasMap()) {
            var navigation = new mapboxgl.NavigationControl();
            this.getMap().addControl(navigation, positon);
            var zoom = new MapBoxZoomControl();
            this.getMap().addControl(zoom, MapBoxMap.CONTROL_POSITION_TOP_LEFT);
        }
    };
    MapBoxMap.prototype.addAttribution = function (positon) {
        if (positon === void 0) { positon = MapBoxMap.CONTROL_POSITION_TOP_RIGHT; }
        if (this.hasMap()) {
            var attribution = new mapboxgl.AttributionControl({
                customAttribution: "Map design by me",
            });
            this.getMap().addControl(attribution, positon);
        }
    };
    MapBoxMap.prototype.setMaxBounds = function (bounds) {
        if (this.getMap()) {
            this.getMap().setMaxBounds([
                [bounds.minLon, bounds.minLat],
                [bounds.maxLon, bounds.minLat],
            ]);
        }
    };
    MapBoxMap.prototype.addSource = function (source) {
        console.log(source);
    };
    MapBoxMap.prototype.getSource = function (id) {
        return this.hasMap() ? this.getMap().getSource(id) : null;
    };
    MapBoxMap.prototype.removeSource = function (id) {
        if (this.hasMap()) {
            this.getMap().removeSource(id);
        }
    };
    MapBoxMap.prototype.addLayer = function (layer, beforeId) {
        console.log(layer, beforeId);
    };
    MapBoxMap.prototype.moveLayer = function (id, beforeId) {
        console.log(id, beforeId);
    };
    MapBoxMap.prototype.removeLayer = function (id) {
        if (this.hasMap()) {
            this.getMap().removeLayer(id);
        }
    };
    MapBoxMap.prototype.getLayer = function (id) {
        console.log(id);
        return null;
    };
    MapBoxMap.prototype.close = function () {
    };
    MapBoxMap.CONTROL_POSITION_TOP_LEFT = "top-left";
    MapBoxMap.CONTROL_POSITION_TOP_RIGHT = "top-left";
    MapBoxMap.CONTROL_POSITION_BOTTOM_LEFT = "bottom-left";
    MapBoxMap.CONTROL_POSITION_BOTTOM_RIGHT = "bottom-right";
    return MapBoxMap;
}(AbstractMap));
export default MapBoxMap;
