import MapBoxSourceConsts from "./consts/MapBoxSourceConsts";
var MapBoxSource = (function () {
    function MapBoxSource() {
        this.tileSize = 256;
        this.scheme = "xyz";
        this.type = MapBoxSourceConsts.SOURCE_TYPE_RASTER;
    }
    MapBoxSource.prototype.setType = function (type) {
        this.type = type;
        if (MapBoxSourceConsts.SOURCE_TYPE_VECTOR === type) {
            this.tileSize = 512;
        }
    };
    MapBoxSource.prototype.setTileUrls = function (tiles) {
        this.tiles = tiles;
    };
    MapBoxSource.prototype.addTileUrl = function (tileUrl) {
        if (!this.tiles) {
            this.tiles = [];
        }
        this.tiles.push(tileUrl);
    };
    MapBoxSource.prototype.setUrl = function (url) {
        this.url = url;
    };
    MapBoxSource.prototype.setData = function (url) {
        if (!this.data) {
            this.data = [];
        }
        else {
            this.data.push(url);
        }
    };
    MapBoxSource.prototype.setTileSize = function (tileSize) {
        this.tileSize = tileSize;
    };
    MapBoxSource.prototype.setScheme = function (scheme) {
        this.scheme = scheme;
    };
    MapBoxSource.prototype.setMinZoom = function (minZoom) {
        this.minzoom = minZoom;
    };
    MapBoxSource.prototype.setMaxZoom = function (maxZoom) {
        this.maxzoom = maxZoom;
    };
    MapBoxSource.prototype.setBounds = function (bounds) {
        this.bounds = bounds;
    };
    MapBoxSource.prototype.addBounds = function (minX, minY, maxX, maxY) {
        this.bounds = [minX, minY, maxX, maxY];
    };
    MapBoxSource.prototype.setAttribution = function (attribution) {
        this.attribution = attribution;
    };
    return MapBoxSource;
}());
export default MapBoxSource;
