import * as MapUtils from "../../util/MapUtils";
var MapBoxStyle = (function () {
    function MapBoxStyle(name) {
        if (name === void 0) { name = "defaultStyle"; }
        this.version = 8;
        this.layers = [];
        this.name = name;
    }
    MapBoxStyle.prototype.setName = function (name) {
        this.name = name;
    };
    MapBoxStyle.prototype.setZoom = function (zoom) {
        this.zoom = zoom;
    };
    MapBoxStyle.prototype.setGlyphs = function (glyphs) {
        this.glyphs = glyphs;
    };
    MapBoxStyle.prototype.setPitch = function (pitch) {
        this.pitch = pitch;
    };
    MapBoxStyle.prototype.setSources = function (sources) {
        this.sources = sources;
    };
    MapBoxStyle.prototype.addSource = function (name, source) {
        var map = MapUtils.objToMap(this.sources);
        map.set(name, source);
        this.sources = MapUtils.mapToObj(map);
    };
    MapBoxStyle.prototype.setLayers = function (layers) {
        this.layers = layers;
    };
    MapBoxStyle.prototype.addLayer = function (layer) {
        this.layers.push(layer);
    };
    return MapBoxStyle;
}());
export default MapBoxStyle;
