import L from "leaflet";
interface Bounds {
    minLat?: number;
    minLon?: number;
    maxLat?: number;
    maxLon?: number;
}
interface LeaftOptions {
    center: any;
    bounds: any;
}
interface LeafletWmtsOptions extends LeaftOptions {
    title: string;
    layer: string;
    tilematrixset: string;
}
interface LeafletWmsOptions extends LeaftOptions {
    layers: string;
}
declare class OgcXmlParser {
    static readonly WMTS = "WMTS";
    static readonly WMS = "WMS";
    static readonly WFS = "WFS";
    static getWmtsCapabilitiesUrl(url: string): string;
    static getWmsCapabilitiesUrl(url: string, version?: string): string;
    static getWmsLayers(xmlData: string): string;
    static getWmtsLayer(xmlData: string): string;
    static getWmtsLayerTitle(xmlData: string): string;
    static getWmtsTileMatrix(xmlData: string): string;
    static getWmtsOptions(xmlData: string): LeafletWmtsOptions;
    static getWmsOptions(xmlData: string, options?: {
        format: string;
        transparent: boolean;
    }): LeafletWmsOptions;
    static getWmsBounds(xmlData: string): Bounds;
    static wrapperBounds(bounds: Bounds): Bounds;
    static getFitBounds(xmlData: string, service?: string): L.LatLngBounds;
    static getWMTSBounds(xmlData: string): Bounds;
    static getOgcCenter(xmlData: string, service?: string): number[];
    static createCoordinate(lat: number, lon: number): L.LatLng;
}
export default OgcXmlParser;
